/***********************************************************************
 *
 * PROJECT: PalmXQ
 * FILE:    eval.c
 * AUTHOR:  Cheok Yan Cheng
 *
 * DESCRIPTION: Board position evaluator.
 *
 * LAST REVISION:   24/02/2002
 *
 ***********************************************************************/

#include <PalmOS.h>
#include "palmxqrsc.h"
#include "data.h"
#include "protos.h"
#include "defs.h"


Int16 Eval(ARMGLOBALS_PROTO_VOID)
{
    Int8  i;
    Int8  j;
    Int16 s = 0;

    for(i = 0; i < BRD_SIZE; i++)
    {

        if (Color[i] == DARK)
        {
            // Dark knight bonus
            if(Piece[i] == KNIGHT)
            {
                for(j = 0; j < 8; j++)
                {
                    if ( -1 == Mailbox182[Mailbox90[i] + Offset[KNIGHT][j]] )
                    {
                        continue;
                    }

                    if(Color[i + KnightCheck[j]] == EMPTY)
                    {
                        s += 1;
                    }
                }
            }

            s += PointTable[Piece[i]][i];
        }
        else if (Color[i]==LIGHT)
        {
            // Light knight bonus
            if(Piece[i] == KNIGHT)
            {
                for(j = 0; j < 8; j++)
                {
                    if ( -1 == Mailbox182[Mailbox90[i] + Offset[KNIGHT][j]] )
                    {
                        continue;
                    }

                    if(Color[i + KnightCheck[j]] == EMPTY)
                    {
                        s -= 1;
                    }
                }
            }

            s -= PointTable[Piece[i]][89 - i];
        }
    }
    if (Side == LIGHT)
    {
        s = -s;
    }

    return s;
}
